Subject: Re: [GSoC PATCH] pathspec: fix sign comparison warnings

From: Junio C Hamano <[email-masked]>
Date: Thu, 13 Mar 2025 08:33:59 -0700

Karthik Nayak <[email-masked]> writes:

> Also a bigger question is, shouldn't the type of `pathspec.nr` and
> 'istate.cache_nr' be the actual change required? Shouldn't they be set
> to 'size_t'?

Please do not blindly advocate the idea that size_t is always the
right type for any countables.  It is not.  

Platform natural way to count things is either "unsigned int", if
you are only counting, or "int", if you need to be able to signal an
unusual state other than "here is now many we have in the set", like
how index related functions uses (-pos-1) to signal a location in
the same range with different meanings.